import React from 'react';
import { IUseVisible } from '../useVisible/useVisible';
import { IBaseElement, ITonal, IColor, IPropsAny } from '../types';
export interface IImage extends IBaseElement {
    tonal?: ITonal;
    color?: IColor;
    src?: string;
    sources?: Array<string>;
    alt?: string;
    description?: string;
    alignDescription?: 'start' | 'left' | 'center' | 'right' | 'end';
    width?: number;
    height?: number;
    lazyLoad?: boolean;
    align?: 'start' | 'left' | 'center' | 'right' | 'end';
    responsive?: boolean;
    fullWidth?: boolean;
    maxWidth?: 'xxs' | 'xs' | 'sm' | 'rg' | 'lg' | 'xl' | 'unset';
    loading?: 'eager' | 'lazy';
    IconNoImage?: any;
    NoImageProps?: IPropsAny;
    DescriptionProps?: IPropsAny;
    UseVisibleProps?: IUseVisible;
}
declare const Image: React.FC<IImage>;
export default Image;
