import React from 'react';
import { ISurface } from '../Surface/Surface';
import { ISize, IElementReference, IPropsAny } from '../types';
export type TWeatherDayTime = 'day' | 'night';
export type TWeather = 'clear' | 'partly clear' | 'rainy' | 'partly rainy' | 'snowy' | 'partly snowy';
export type TTemperature = number;
export interface IWeather extends ISurface {
    size?: ISize;
    shadow?: boolean;
    dayTime?: TWeatherDayTime;
    weather?: TWeather;
    temperature?: TTemperature;
    values?: {
        dayTime?: TWeatherDayTime;
        weather?: TWeather;
        temperature?: TTemperature;
    };
    interval?: number;
    IconDay?: IElementReference;
    IconNight?: IElementReference;
    IconCloud?: IElementReference;
    IconRain?: IElementReference;
    IconSnow?: IElementReference;
    IconProps?: IPropsAny;
}
declare const Weather: React.FC<IWeather>;
export default Weather;
